
#ifndef VREAD
#define VREAD

#include "vutil.h"

/* Header file for vread.c */

/* Basic typedefs and structure definitions */

typedef struct { int degen, loca, locb;
                 char *site; }  POLYSITE;

/* For codon to amino-acid translation arrays */

typedef struct { char aname[5], amtag;
                 int  gflag;
                 char signature[4];
                 int codoncnt; }  AACODE;

/* Exportable variables */

extern char **strtag, **readtag, **strshtag, **seqbase;
extern STRLIST seqs_notused, seqfcomments, configcomments;
extern int nseqs, file_nseqs, nbases, blocnum, seqf_open;
extern int r_polyflag, reread_polymorphisms, numutconv;
extern int npairseqs, noutseqs, noutgrps;
extern int numdelblocs, maxdelblocs, numdelsing, mxtag, gxtag;
extern int have_silent_multsites, maxsqlinelen;
/* Seqrpoff is used only for Listed Polymorphism format */
extern int *seqrpoff;

extern int org_bsize, org_bnum;

extern POLYSITE  *polysites, *sitend, *polysave;
extern int  npolys;

extern AACODE codn[];

/* Open <Seqfile> functions */

void OpenSeqFile(void);
void CloseSeqFile(void);
char *set_offtypes (void);
void destroy_stag(void);
void new_bloc_groups(void);
void say_toofewpolys(void);
char *get_ffname(void);
int use_commchars(void);

void init_readvars(void);

/* Read <Seqfile> helper functions */
void setgroups (void);
void build_simple_group(int usekeep);
void build_bloc_groups(int usekeep);
void set_bloc_names(void);
void set_groupvars(void);

void read_polys(void);
void make_poly_save(int resize);
void run_comments(void);
void show_restricts(void);

typedef struct { int lf,rt,caf; } FRAGOFFS;

FRAGOFFS offsfrags (int start, int finish);
int offsetlen (int rstart, int rfin);

char *codonval(int i);
void setdna(int mitcodes);
void show_codon_stats(void);

void set_kchars(void);
char *set_pchars(void);
void show_basedata(void);

#endif /* VREAD */

